app/apps/core/urls.py
from django.urls import path
from django.views.generic import TemplateView

from core.views import (Home,
                        DocumentsList,
                        DocumentDetail,
                        CreateDocument,
                        UpdateDocument,
                        EditPart,
                        DocumentImages,
                        ModelsList,
                        ModelDelete,
                        ModelCancelTraining,
                        PublishDocument,
                        ShareDocument,
                        DocumentPartsProcessAjax)

urlpatterns = [
    path('', Home.as_view(), name='home'),
    path('documents/', DocumentsList.as_view(), name='documents-list'),
    path('document/<int:pk>/', DocumentDetail.as_view(), name='document-detail'),
    path('document/create/', CreateDocument.as_view(), name='document-create'),
    path('document/<int:pk>/edit/', UpdateDocument.as_view(), name='document-update'),
    path('document/<int:pk>/parts/edit/', EditPart.as_view(), name='document-part-edit'),
    path('document/<int:pk>/part/<int:part_pk>/edit/', EditPart.as_view(),
         name='document-part-edit'),
    path('document/<int:pk>/images/', DocumentImages.as_view(), name='document-images'),
    path('models/', ModelsList.as_view(), name='user-models'),
    path('model/<int:pk>/delete/', ModelDelete.as_view(), name='model-delete'),
    path('model/<int:pk>/cancel_training/', ModelCancelTraining.as_view(),
         name='model-cancel-training'),
    path('document/<int:document_pk>/models/', ModelsList.as_view(), name='document-models'),
    path('document/<int:pk>/publish/', PublishDocument.as_view(), name='document-publish'),
    path('document/<int:pk>/share/', ShareDocument.as_view(), name='document-share'),
    path('document/<int:pk>/process/', DocumentPartsProcessAjax.as_view(),
         name='document-parts-process'),

    path('test/', TemplateView.as_view(template_name='core/test.html')),
]

app/escriptorium/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include
from django.views.generic import TemplateView

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('core.urls')),
    path('', include('users.urls')),
    path('', include('reporting.urls')),
    path('api/', include('api.urls', namespace='api')),
    path(r'captcha/', include('captcha.urls')),
]

if settings.DEBUG:
    try:
        import debug_toolbar
    except ImportError:
        pass
    else:
        urlpatterns += [path('__debug__/', include(debug_toolbar.urls)),]

    # simulates a 500 to test error logging
    from django.views.defaults import server_error
    urlpatterns += [path('500/', server_error),
                    path('404/', TemplateView.as_view(template_name='404.html'))]


    # Serve static files in developement
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

app/apps/core/models.py
import re
import logging
import math
import os
import json
import functools
import subprocess
import uuid
from PIL import Image
from datetime import datetime
from shapely import affinity
from shapely.geometry import Polygon, LineString

from django.db import models, transaction
from django.db.models import Q, Prefetch
from django.db.models.signals import pre_delete
from django.conf import settings
from django.contrib.auth import get_user_model
from django.contrib.auth.models import Group
from django.contrib.postgres.fields import JSONField
from django.core.validators import FileExtensionValidator
from django.dispatch import receiver
from django.forms import ValidationError
from django.utils.functional import cached_property
from django.utils.text import slugify
from django.utils.translation import gettext_lazy as _

from celery.task.control import inspect, revoke
from celery import chain
from django_redis import get_redis_connection
from easy_thumbnails.files import get_thumbnailer
from ordered_model.models import OrderedModel
from kraken import blla, rpred
from kraken.binarization import nlbin
from kraken.lib import vgsl, models as kraken_models
from kraken.lib.util import is_bitonal
from kraken.lib.segmentation import calculate_polygonal_environment

from versioning.models import Versioned
from core.tasks import (segtrain, train, binarize,
                        lossless_compression, convert, segment, transcribe,
                        generate_part_thumbnails)
from users.consumers import send_event

redis_ = get_redis_connection()
User = get_user_model()
logger = logging.getLogger(__name__)


class ProcessFailureException(Exception):
    pass


class AlreadyProcessingException(Exception):
    pass


class Typology(models.Model):
    name = models.CharField(max_length=128)

    # if True, is visible as a choice in the ontology edition in a new document
    public = models.BooleanField(default=False)
    # if True, is a valid choice by default in a new document
    default = models.BooleanField(default=False)

    class Meta:
        abstract = True

    def __str__(self):
        return self.name


class DocumentType(Typology):
    pass


class DocumentPartType(Typology):
    pass


class BlockType(Typology):
    pass


class LineType(Typology):
    pass


class Metadata(models.Model):
    name = models.CharField(max_length=128, unique=True)
    cidoc_id = models.CharField(max_length=8, null=True, blank=True)
    public = models.BooleanField(default=False)

    class Meta:
        ordering = ('name',)

    def __str__(self):
        return self.name


class Script(models.Model):
    TEXT_DIRECTION_HORIZONTAL_LTR = 'horizontal-lr'
    TEXT_DIRECTION_HORIZONTAL_RTL = 'horizontal-rl'
    TEXT_DIRECTION_VERTICAL_LTR = 'vertical-lr'
    TEXT_DIRECTION_VERTICAL_RTL = 'vertical-rl'
    TEXT_DIRECTION_TTB = 'ttb'
    TEXT_DIRECTION_CHOICES = (
        ((TEXT_DIRECTION_HORIZONTAL_LTR, _("Horizontal l2r")),
         (TEXT_DIRECTION_HORIZONTAL_RTL, _("Horizontal r2l")),
         (TEXT_DIRECTION_VERTICAL_LTR, _("Vertical l2r")),
         (TEXT_DIRECTION_VERTICAL_RTL, _("Vertical r2l")),
         (TEXT_DIRECTION_TTB, _("Top to bottom")))
    )

    name = models.CharField(max_length=128)
    name_fr = models.CharField(max_length=128, blank=True)
    iso_code = models.CharField(max_length=4, blank=True)
    text_direction = models.CharField(max_length=64, default='horizontal-lr',
                                      choices=TEXT_DIRECTION_CHOICES)

    class Meta:
        ordering = ('name',)

    def __str__(self):
        return self.name


class DocumentMetadata(models.Model):
    document = models.ForeignKey('core.Document', on_delete=models.CASCADE)
    key = models.ForeignKey(Metadata, on_delete=models.CASCADE)
    value = models.CharField(max_length=512)

    def __str__(self):
        return '%s:%s' % (self.document.name, self.key.name)


class DocumentManager(models.Manager):
    def get_queryset(self):
        return super().get_queryset().select_related('typology')

    def for_user(self, user):
        # return the list of editable documents
        # Note: Monitor this query
        return (Document.objects
                .filter(Q(owner=user)
                        | (Q(workflow_state__gt=Document.WORKFLOW_STATE_DRAFT)
                           & (Q(shared_with_users=user)
                              | Q(shared_with_groups__in=user.groups.all()))))
                .exclude(workflow_state=Document.WORKFLOW_STATE_ARCHIVED)
                .prefetch_related('shared_with_groups', 'transcriptions')
                .select_related('typology')
                .distinct())


class Document(models.Model):
    WORKFLOW_STATE_DRAFT = 0
    WORKFLOW_STATE_SHARED = 1  # editable a viewable by shared_with people
    WORKFLOW_STATE_PUBLISHED = 2  # viewable by the world
    WORKFLOW_STATE_ARCHIVED = 3  #
    WORKFLOW_STATE_CHOICES = (
        (WORKFLOW_STATE_DRAFT, _("Draft")),
        (WORKFLOW_STATE_SHARED, _("Shared")),
        (WORKFLOW_STATE_PUBLISHED, _("Published")),
        (WORKFLOW_STATE_ARCHIVED, _("Archived")),
    )
    READ_DIRECTION_LTR = 'ltr'
    READ_DIRECTION_RTL = 'rtl'
    READ_DIRECTION_CHOICES = (
        (READ_DIRECTION_LTR, _("Left to right")),
        (READ_DIRECTION_RTL, _("Right to left")),
    )

    name = models.CharField(max_length=512)

    owner = models.ForeignKey(User, null=True, on_delete=models.SET_NULL)
    workflow_state = models.PositiveSmallIntegerField(
        default=WORKFLOW_STATE_DRAFT,
        choices=WORKFLOW_STATE_CHOICES)
    shared_with_users = models.ManyToManyField(User, blank=True,
                                               verbose_name=_("Share with users"),
                                               related_name='shared_documents')
    shared_with_groups = models.ManyToManyField(Group, blank=True,
                                                verbose_name=_("Share with teams"),
                                                related_name='shared_documents')

    main_script = models.ForeignKey(Script, null=True, blank=True, on_delete=models.SET_NULL)
    read_direction = models.CharField(
        max_length=3,
        choices=READ_DIRECTION_CHOICES,
        default=READ_DIRECTION_LTR
    )
    typology = models.ForeignKey(DocumentType, null=True, blank=True, on_delete=models.SET_NULL)

    # A list of Typology(ies) which are valid to this document. Part of the document's ontology.
    valid_block_types = models.ManyToManyField(BlockType, blank=True, related_name='valid_in')
    valid_line_types = models.ManyToManyField(LineType, blank=True, related_name='valid_in')

    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)

    metadatas = models.ManyToManyField(Metadata, through=DocumentMetadata, blank=True)

    objects = DocumentManager()

    class Meta:
        ordering = ('-updated_at',)

    def __str__(self):
        return self.name

    def save(self, *args, **kwargs):
        res = super().save(*args, **kwargs)
        Transcription.objects.get_or_create(document=self, name=_(Transcription.DEFAULT_NAME))
        return res

    @property
    def is_shared(self):
        return self.workflow_state in [self.WORKFLOW_STATE_PUBLISHED,
                                       self.WORKFLOW_STATE_SHARED]

    @property
    def is_published(self):
        return self.workflow_state == self.WORKFLOW_STATE_PUBLISHED

    @property
    def is_archived(self):
        return self.workflow_state == self.WORKFLOW_STATE_ARCHIVED

    @cached_property
    def is_transcribing(self):
        return (self.parts.filter(workflow_state__gte=DocumentPart.WORKFLOW_STATE_TRANSCRIBING)
                .first() is not None)

    @cached_property
    def default_text_direction(self):
        if self.main_script:
            if self.main_script.text_direction == Script.TEXT_DIRECTION_HORIZONTAL_RTL:
                return 'rtl'
            else:
                return 'ltr'
        else:
            if self.read_direction == self.READ_DIRECTION_RTL:
                return 'rtl'
            else:
                return 'ltr'

    @property
    def training_model(self):
        return self.ocr_models.filter(training=True).first()


def document_images_path(instance, filename):
    return 'documents/{0}/{1}'.format(instance.document.pk, filename)


class DocumentPart(OrderedModel):
    """
    Represents a physical part of a larger document that is usually a page
    """
    name = models.CharField(max_length=512, blank=True)
    image = models.ImageField(upload_to=document_images_path)
    original_filename = models.CharField(max_length=1024, blank=True)
    source = models.CharField(max_length=1024, blank=True)
    bw_backend = models.CharField(max_length=128, default='kraken')
    bw_image = models.ImageField(upload_to=document_images_path,
                                 null=True, blank=True,
                                 help_text=_("Binarized image needs to be the same size as original image."))
    typology = models.ForeignKey(DocumentPartType, null=True, blank=True,
                                 on_delete=models.SET_NULL)
    document = models.ForeignKey(Document, on_delete=models.CASCADE, related_name='parts')
    order_with_respect_to = 'document'

    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)

    WORKFLOW_STATE_CREATED = 0
    WORKFLOW_STATE_CONVERTING = 1
    WORKFLOW_STATE_CONVERTED = 2
    # WORKFLOW_STATE_BINARIZING = 3  # legacy
    # WORKFLOW_STATE_BINARIZED = 4
    WORKFLOW_STATE_SEGMENTING = 5
    WORKFLOW_STATE_SEGMENTED = 6
    WORKFLOW_STATE_TRANSCRIBING = 7
    WORKFLOW_STATE_CHOICES = (
        (WORKFLOW_STATE_CREATED, _("Created")),
        (WORKFLOW_STATE_CONVERTING, _("Converting")),
        (WORKFLOW_STATE_CONVERTED, _("Converted")),
        (WORKFLOW_STATE_SEGMENTING, _("Segmenting")),

app/escriptorium/templates/core/document_form.html
{% extends 'core/document_nav.html' %}
{% load i18n staticfiles bootstrap %}
{% block head_title %}{% if object %}{% trans "Update a Document" %}{% else %}{% trans "Create a new Document" %}{% endif %}{% endblock %}

{% block nav-doc-active %}active{% endblock %}

{% block extra_nav %}
{% if object and can_publish %}
<div class="ml-auto">
    <button type="button" class="nav-item btn btn-primary mr-1" data-toggle="modal" data-target="#shareModal" title="{% trans "Share" %}"><i class="fas fa-share"></i></button>
    {% comment %}
    {% if not object.is_published %}
    <form method="post" class="inline-form" action="{% url 'document-publish' pk=object.pk %}">{% csrf_token %}
        <input type="hidden" name="workflow_state" value="{{ object.WORKFLOW_STATE_PUBLISHED }}">
        <button type="submit" value="{% trans 'Publish' %}" class="nav-item btn btn-success mr-1" title="{% trans 'Publish' %}">
            <i class="fas fa-globe-europe"></i>
        </button>
    </form>
    {% endif %}
    {% endcomment %}
    <form method="post" class="inline-form" action="{% url 'document-publish' pk=object.pk %}" onsubmit="return confirm('{% trans "Do you really want to delete the document?" %}');">{% csrf_token %}
        <input type="hidden" name="workflow_state" value="{{ object.WORKFLOW_STATE_ARCHIVED }}">
        <button type="submit" value="" class="nav-item btn btn-danger" title="{% trans 'Delete' %}"><i class="fas fa-trash"></i></button>
    </form>
</div>
{% endif %}
{% endblock %}

{% block tab_content %}
<div class="tab-pane fade show active" id="nav-doc" role="tabpanel" aria-labelledby="nav-doc-tab">
    <form id="document-form" method="post">
        {% csrf_token %}
        <fieldset>
            <div class="form-group">
                {% for err in form.non_field_errors %}
                <p class="error">{{ err }}</p>
                {% endfor %}
            </div>

            {% if object %}
            {% render_field form.name %}
            {% else %}
            {% render_field form.name autofocus=1 %}
            {% endif %}

            {% render_field form.main_script %}
            {% render_field form.read_direction %}
            {# render_field form.typology #}

            <div class="row">
                <div id="metadata-form" class="col-xl js-metadata-form">
                    <label class="my-1">{% trans "Metadata" %}</label>
                    {{ metadata_form.management_form }}

                    {% for subform in metadata_form.forms %}
                    <div class="input-group input-group-sm mb-2 js-metadata-row">
                        {{ subform.id }}  {# hidden #}
                        {{ subform.document }}  {# hidden #}
                        <div class="input-group-sm input-group-prepend">
                            {% render_field subform.key group=True autocomplete="on" list="metadataKeys" class="input-group-text" %}
                        </div>
                        {% render_field subform.value group=True %}
                        <div class="input-group-prepend">
                            <input type="hidden" name="documentmetadata_set-{{forloop.counter0}}-DELETE" id="id_documentmetadata_set-{{forloop.counter0}}-DELETE">
                            <button class="btn btn-outline-secondary js-metadata-delete" type="button" for="id_documentmetadata_set-{{forloop.counter0}}-DELETE">✗</button>
                        </div>
                    </div>
                    {% for errors in subform.errors.values %}{% for error in errors %}<div class="text-danger mb-2">{{ error }}</div>{% endfor %}{% endfor %}
                    {% endfor %}

                    {% if metadata_form.forms.0.choices %}
                    <datalist id="metadataKeys">
                        {% for md in metadata_form.forms.0.choices %}
                        <option>{{ md.name }}</option>
                        {% endfor %}
                    </datalist>
                    {% endif %}
                </div>

                <div id="ontology-form" class="col-xl">
                    <label class="my-1">{% trans "Ontology" %}</label>

                    <button type="button" class="btn help open" aria-label="Help">
                        <span class="fas fa-question"></span>
                    </button>
                    <div id="ontology-help" class="alert alert-primary help-text">
                        <button type="button" class="close" aria-label="Close">
                            <span aria-hidden="true">×</span>
                        </button>
                        <p class="form-text text-muted mb-0">{% trans "The default configuration only contains semantic types. <br>It is not recommended to mix semantic, stylistic and layout types.<br><b>It is required to hit 'Update' to add your new types to the document.</b>" %}</p>
                    </div>


                    <div id="region-types">
                        <div><small>{% trans "Region types" %}</small></div>
                        {% render_field form.valid_block_types group=True %}
                        <!-- free input handleed by js-->
                        <div class="form-row">
                            <div class="col">
                                <input class="form-control form-control-sm"
                                       id="add-region-type-input"
                                       placeholder="{% trans "Add a region type" %}" />
                            </div>
                            <div class="col-auto">
                                <button id="add-region-type-btn"
                                        class="btn btn-success fas fa-plus"></button>
                            </div>
                        </div>
                    </div>

                    <div id="line-types">
                        <div class="mt-2"><small>{% trans "Line types" %}</small></div>
                        {% render_field form.valid_line_types group=True %}
                        <div class="form-row">
                            <div class="col">
                                <input class="form-control form-control-sm"
                                       id="add-line-type-input"
                                       placeholder="{% trans "Add a line type" %}" />
                            </div>
                            <div class="col-auto">
                                <button id="add-line-type-btn"
                                        class="btn btn-success fas fa-plus"></button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <input type="submit" value="{% if object %}{% trans 'Update' %}{% else %}{% trans 'Create' %}{% endif %}" class="btn btn-success btn-block my-3" {% if object %}autofocus{% endif %}>
        </fieldset>
    </form>
</div>
{% endblock %}

{% block modals %}
{% if share_form %}
<!-- shareModal -->
<div class="modal fade" id="shareModal" tabindex="-1" role="dialog" aria-labelledby="shareModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <form method="post" action="{% url 'document-share' pk=object.pk %}">
                {% csrf_token %}

                <div class="modal-header">
                    <h3 class="modal-title" id="exampleModalLabel">{% trans "Share with" %}</h3>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <h5>{% trans "Teams" %}</h5>
                    {% render_field share_form.shared_with_groups %}
                    <h5>{% trans "Users" %}</h5>
                    {% render_field share_form.username %}
                    {% render_field share_form.shared_with_users %}
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                    <input type="submit" value="{% trans 'Share' %}" class="btn btn-primary">
                </div>
            </form>
        </div>
    </div>
</div>
{% endif %}
{% endblock %}

{% block scripts %}
<script type="text/javascript">
 {% if user.onboarding %}
 const ONBOARDING_PAGE = 'onboarding_document_form';
 {% endif %}
</script>
{{ block.super }}
<script type="text/javascript">
    $(document).ready(function(){
      bootDocumentForm();
      bootHelp();
    });
</script>
{% endblock %}

app/escriptorium/templates/core/document_images.html
{% extends 'core/document_nav.html' %}
{% load i18n staticfiles bootstrap thumbnail %}
{% block styles %}

{# custom jquery ui build with draggable and resizable only #}
{{ block.super }}
{% endblock %}

{% block nav-images-active %}active{% endblock %}

{% block tab_content %}
<div id="dropzone">
  <form action="{% url 'api:part-list' document_pk=document.pk %}" class="dropzone dz-clickable mb-2" id="document-image-dropzone">
    {% csrf_token %}
    <div class="dz-message"><i class="fas fa-upload"></i> {% trans "Drop images here or click to upload." %}</div>
  </form>
</div>
<div>
  <div class="multi-proc d-flex">
    <button id="select-all" class="btn btn-sm btn-info mr-1">{% trans "Select all" %}</button>
    <button id="unselect-all" class="btn btn-sm btn-info mr-1">{% trans "Unselect all" %}</button>
    <span>{% trans "Loading" %} <span id="loading-counter"></span>...</span>
    <span>{% trans "Selected" %} <span id="selected-counter"></span></span>
    <div class="btn-group ml-auto mr-1" role="group">
      <button id="import-selected" type="button" class="btn btn-sm btn-primary dropdown-toggle" data-toggle="dropdown">
        <i class="fas fa-file-import mr-1"></i>{% trans "Import" %}
      </button>
      <div class="dropdown-menu">
          <a data-proc="import-iiif" class="js-proc-selected dropdown-item" href="#">Images (IIIF)</a>
          <a data-proc="import-pdf" class="js-proc-selected dropdown-item" href="#">Images (PDF)</a>
        <a data-proc="import-xml" class="js-proc-selected dropdown-item" href="#">Transcriptions (XML)</a>
      </div>
    </div>
    {% with import=import_form.current_import %}
    <span class="import-counter-container {% if import and import.ongoing %}ongoing{% endif %}">{% trans "Importing" %}
      <span id="import-counter">{% if import %}{% if import.total %}{{import.processed}}/{{import.total}}{% else %}pending{% endif %}{% endif %}</span>...
      <button id="cancel-import" class="btn btn-sm btn-warning mr-1"><i class="fas fa-ban"></i></button>
    </span>
    {% endwith %}

    {% if document.transcriptions.count %}
    <button id="document-export" type="button" class="btn btn-sm btn-primary js-proc-selected ml-1" title="{% trans "Export" %}" data-proc="export">
      <i class="fas fa-file-export mr-1"></i>{% trans "Export" %}
    </button>
    {% endif %}

    {% if perms.core.can_train %}
    {% with training_model=document.training_model %}
    <div class="btn-group ml-auto mr-1" role="group">
    <button id="train-selected" type="button" class="btn btn-sm btn-primary dropdown-toggle {% if training_model %}blink{% endif %}" title="{% trans 'Train a segmenter/recognizer model.' %}" data-toggle="dropdown">
      <i class="fas fa-subway mr-1"></i>{% trans "Train" %}
    </button>
    <div class="dropdown-menu">
      <a data-proc="segtrain" class="js-proc-selected dropdown-item" href="#">Segmenter</a>
      <a data-proc="train" class="js-proc-selected dropdown-item" href="#">Recognizer</a>
    </div>
    </div>
    <button id="cancel-training" class="btn btn-sm btn-warning {% if not training_model %}hide{% endif %}" title="{% trans "Cancel training" %}"><i class="fas fa-ban"></i></button>
    {% endwith %}
    {% endif %}
    <button id="binarize-selected" class="btn btn-sm btn-primary mr-1 ml-auto js-proc-selected" data-proc="binarize" title="{% trans 'Binarize selected images.' %}"><i class="fas fa-adjust mr-1"></i>{% trans "Binarize" %}</button>
    <button id="segment-selected" class="btn btn-sm btn-primary mr-1 js-proc-selected" data-proc="segment" title="{% trans 'Segment selected images.' %}"><i class="fas fa-align-left mr-1"></i>{% trans "Segment" %}</button>
    <button id="transcribe-selected" class="btn btn-sm btn-primary mr-1 js-proc-selected" data-proc="transcribe" title="{% trans 'Start transcribing selected images.' %}"><i class="fas fa-language mr-1"></i>{% trans "Transcribe" %}</button>
  </div>
</div>

<div id="cards-container" class="mt-2 d-flex flex-row flex-nowrap {{ document.read_direction }}">
  <div class="dropable js-drop"></div>
  {# card are created through the dom api (see below) #}
</div>
{% endblock %}

{% block modals %}
{# template for adding card #}
<div id="card-template">
  <div id="image-card-{pk}" class="card">
    <div style="position: relative;">
      <button class="js-card-select-hdl"><i class="fas fa-square"></i></button>
      <button title="{% trans 'Delete this image and all its data (segmentation, transcriptions)' %}" class="close mr-1 js-card-delete" aria-label="Close"><span aria-hidden="true">&times;</span></button>
      <img style="object-fit: cover;" width="180" height="180" class="card-img-top lazy">
      <div class="card-btns">
        <button class="btn card-btn btn-warning js-cancel" title="{% trans 'Cancel tasks' %}"><i class="fas fa-ban"></i></button>
        <button class="btn card-btn btn-info js-edit" id="js-edit" title="{% trans 'Edit' %}"><i class="fas fa-edit"></i></button>
      </div>
    </div>
    <div class="card-body">
      <div class="d-flex mt-2">
        <span class="js-compressing mr-2" data-title="{% trans 'Compressing' %}"><i class="fas fa-compress-arrows-alt"></i></span>
        <span class="btn proc js-binarized" data-title="{% trans 'Binarize' %}"><i class="fas fa-adjust"></i></span>
        <span class="btn proc ml-2 js-segmented" data-title="{% trans 'Segment' %}"><i class="fas fa-align-left"></i></span>
        <span class="btn proc ml-2 js-trans-progress" data-title="{% trans 'Transcribe' %}">
          <span class="progress-bar" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100">0%</span>
        </span>
      </div>
    </div>
  </div>
  <div class="dropable js-drop"></div>
</div>

{# Process wizards #}
{% include 'core/wizards/import_iiif.html' with proc='import-iiif' %}
{% include 'core/wizards/import_file.html' with proc='import-xml' %}
{% include 'core/wizards/import_pdf.html' with proc='import-pdf' %}
{% include 'core/wizards/export.html' with proc='export' %}
{% include 'core/wizards/binarize.html' with proc='binarize' %}
{% include 'core/wizards/segment.html' with proc='segment' %}
{% include 'core/wizards/segtrain.html' with proc='segtrain' %}
{% include 'core/wizards/train.html' with proc='train' %}
{% include 'core/wizards/transcribe.html' with proc='transcribe' %}
{% endblock %}

{% block scripts %}
<script type="text/javascript">
 'use strict';
 const DOCUMENT_ID = {{ document.pk }};
 {% if user.onboarding %}
 const ONBOARDING_PAGE = 'onboarding_images';
 {% endif %}
</script>

{{ block.super }}
<script type="text/javascript">
  $(document).ready(function() {
    // join the ws room
    joinDocumentRoom('{{document.pk}}');
    bootImageCards(DOCUMENT_ID);
    bootLazyload();
    bootHelp();
  });
</script>
{% endblock %}

app/escriptorium/templates/core/home.html
{% extends 'base.html' %}
{% load i18n %}
{% block head_title %}{% trans "Homepage" %}{% endblock %}

{% block nav-home-class %}active{% endblock %}

{% block body %}
<div class="jumbotron">
  <h1>eScriptorium</h1>
  <p>{% trans "A project providing digital recognition of handwritten documents using machine learning techniques." %}</p>
  <p><small>Version {{ VERSION_DATE }}
    <br/>{{ KRAKEN_VERSION }}</small></p>
</div>
{% endblock %}